=== debian/changelog ===
libdatachannel-dmo (1:0.23.2-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 06 Sep 2025 08:04:44 +0200
