=== debian/changelog ===
libdatachannel-dmo (1:0.24.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 17 Nov 2025 08:44:49 +0100
