=== debian/control ===
Source: libdatachannel-dmo
Section: libs
Priority: optional
Maintainer: Christian Marillat <marillat@deb-multimedia.org>
Bugs: mailto:marillat@deb-multimedia.org
Homepage: https://github.com/paullouisageneau/libdatachannel
Standards-Version: 4.7.2
Build-Depends: debhelper-compat (= 13), cmake, ninja-build, nlohmann-json3-dev,
 libusrsctp-dev, libsrtp2-dev, libssl-dev

Package: libdatachannel0.24
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends},
Description: C/C++ WebRTC network library - runtime libraries
 A standalone implementation of WebRTC Data Channels, WebRTC Media
 Transport, and WebSockets in C++17 with C bindings for POSIX platforms
 (including GNU/Linux, Android, FreeBSD, Apple macOS and iOS) and Microsoft
 Windows. WebRTC is a W3C and IETF standard enabling real-time peer-to-peer
 data and media exchange between two devices.
 .
 The library aims at being both straightforward and lightweight with minimal
 external dependencies, to enable direct connectivity between native
 applications and web browsers without the pain of importing Google's
 bloated reference library. The interface consists of somewhat simplified
 versions of the JavaScript WebRTC and WebSocket APIs present in browsers,
 in order to ease the design of cross-environment applications.

Package: libdatachannel-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libdatachannel0.24 (= ${binary:Version}), ${misc:Depends},
Description: C/C++ WebRTC network library - development files
 A standalone implementation of WebRTC Data Channels, WebRTC Media
 Transport, and WebSockets in C++17 with C bindings for POSIX platforms
 (including GNU/Linux, Android, FreeBSD, Apple macOS and iOS) and Microsoft
 Windows. WebRTC is a W3C and IETF standard enabling real-time peer-to-peer
 data and media exchange between two devices.
 .
 The library aims at being both straightforward and lightweight with minimal
 external dependencies, to enable direct connectivity between native
 applications and web browsers without the pain of importing Google's
 bloated reference library. The interface consists of somewhat simplified
 versions of the JavaScript WebRTC and WebSocket APIs present in browsers,
 in order to ease the design of cross-environment applications.
