=== debian/changelog ===
libdatachannel-dmo (1:0.24.1-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 19 Jan 2026 01:22:32 +0100
