=== debian/control ===
--- 
+++ 
@@ -1,10 +1,9 @@
 Source: libdatachannel-dmo
 Section: libs
-Priority: optional
 Maintainer: Christian Marillat <marillat@deb-multimedia.org>
 Bugs: mailto:marillat@deb-multimedia.org
 Homepage: https://github.com/paullouisageneau/libdatachannel
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Build-Depends: debhelper-compat (= 13), cmake, ninja-build, nlohmann-json3-dev,
  libusrsctp-dev, libsrtp2-dev, libssl-dev
